#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/sleep.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#define PoC1 0
#define PoC2 1

//structura ce retine butoanele
typedef struct _Led {
	uint8_t pos[2];
	volatile uint8_t *port[2];
} Led ;
Led led[3][3];


int i,j;


void set_led() {
	
	DDRB = 0xFF;
	DDRA = 0xFF;
	DDRC = 0xFF;
	DDRD = 0xFF;
	
	PORTA = 0;
	PORTB = 0;
	PORTC = 0;
	PORTD = 0;
	
	// BUTOANE
	DDRA &= ~(1<<PA0);
	DDRA &= ~(1<<PA1);
	DDRA &= ~(1<<PA2);
	DDRA &= ~(1<<PA3);
	DDRA &= ~(1<<PA4);
	DDRA &= ~(1<<PA4);
	DDRA &= ~(1<<PA5);
	DDRA &= ~(1<<PA6);
	DDRA &= ~(1<<PA7);
	DDRD &= ~(1<<PD0);
	
	PORTA |= (1 << PA0);
	PORTA |= (1 << PA1);
	PORTA |= (1 << PA2);
	PORTA |= (1 << PA3);
	PORTA |= (1 << PA4);
	PORTA |= (1 << PA5);
	PORTA |= (1 << PA6);
	PORTA |= (1 << PA7);
	PORTD |= (1 << PD0);

	led[0][0].pos[PoC1] = PC4;
	led[0][0].port[PoC1] = &PORTC;

	led[0][1].pos[PoC1] = PB7;
	led[0][1].port[PoC1] = &PORTB;
	led[0][1].pos[PoC2] = PB6;
	led[0][1].port[PoC2] = &PORTB;
	
	led[0][2].pos[PoC1] = PB1;
	led[0][2].port[PoC1] = &PORTB;
	led[0][2].pos[PoC2] = PB0;
	led[0][2].port[PoC2] = &PORTB;

	led[1][0].pos[PoC1] = PC6;
	led[1][0].port[PoC1] = &PORTC;
	led[1][0].pos[PoC2] = PC5;
	led[1][0].port[PoC2] = &PORTC;

	led[1][1].pos[PoC1] = PC0;
	led[1][1].port[PoC1] = &PORTC;
	led[1][1].pos[PoC2] = PD1;
	led[1][1].port[PoC2] = &PORTD;
		
	led[1][2].pos[PoC1] = PB3;
	led[1][2].port[PoC1] = &PORTB;
	led[1][2].pos[PoC2] = PB2;
	led[1][2].port[PoC2] = &PORTB;

	led[2][0].pos[PoC1] = PD4;
	led[2][0].port[PoC1] = &PORTD;
	led[2][0].pos[PoC2] = PD5;
	led[2][0].port[PoC2] = &PORTD;

	led[2][1].pos[PoC1] = PC2;
	led[2][1].port[PoC1] = &PORTC;
	led[2][1].pos[PoC2] = PC1;
	led[2][1].port[PoC2] = &PORTC;
	
	led[2][2].pos[PoC1] = PB5;
	led[2][2].port[PoC1] = &PORTB;
	led[2][2].pos[PoC2] = PB4;
	led[2][2].port[PoC2] = &PORTB;


}

//functie care verifica daca un buton a fost apasat
int button_pressed(int which) {

	if (bit_is_clear(PINA, which)) {
		_delay_ms(1000);
		if (bit_is_clear(PINA,which)) return 1;
	}
	return 0;
}

//functie ce aprinde ledurile in functie de ce buton este apasat
void light_pressed(){
	
	if (button_pressed(PA1))
		*(led[0][0].port[PoC1]) |= (1 << led[0][0].pos[PoC1]);
		
	if (button_pressed(PA4))
		*(led[0][1].port[PoC1]) |= (1 << led[0][1].pos[PoC1]);
		
	if (button_pressed(PA7))
		*(led[0][2].port[PoC1]) |= (1 << led[0][2].pos[PoC1]);
		
	if (button_pressed(PA0))
		*(led[1][0].port[PoC1]) |= (1 << led[1][0].pos[PoC1]);
		
	if (button_pressed(PA3))
		*(led[1][1].port[PoC1]) |= (1 << led[1][1].pos[PoC1]);
		
	if (button_pressed(PA6))
		*(led[1][2].port[PoC1]) |= (1 << led[1][2].pos[PoC1]);
		
	if (button_pressed(PD0))
		*(led[2][0].port[PoC1]) |= (1 << led[2][0].pos[PoC1]);
		
	if (button_pressed(PA2))
		*(led[2][1].port[PoC1]) |= (1 << led[2][1].pos[PoC1]);
		
	if (button_pressed(PA5))
		*(led[2][2].port[PoC1]) |= (1 << led[2][2].pos[PoC1]);
	


}

//aprinde toate ledurile
void all_led()
{

	for( i = 0 ; i < 3 ; i ++ )
		for( j = 0 ; j < 3; j ++ )
			*(led[i][j].port[PoC1]) |= (1 << led[i][j].pos[PoC1]);

}

//stinge toate ledurile
void clean_led()
{
	int i, j;
		for( i = 0 ; i < 3 ; i ++ )
			for( j = 0 ; j < 3; j ++ ){
				*(led[i][j].port[PoC1]) &= ~(1 << led[i][j].pos[PoC1]);
				
			}
			

}

//aprinde un rand dat
void lit_row(int row)
{
	
	for( i = 0 ; i < 3 ; i ++ ){
			*(led[row][i].port[PoC1]) |= (1 << led[row][i].pos[PoC1]);
			*(led[row][i].port[PoC1]) |= (1 << led[row][i].pos[PoC1]);
			*(led[row][i].port[PoC1]) |= (1 << led[row][i].pos[PoC1]);
		}
	
}	

//stinge un rand dat	
void clean_row(int row){
	for( i = 0 ; i < 3 ; i ++ ){
			*(led[row][i].port[PoC1]) &= ~(1 << led[row][i].pos[PoC1]);
			*(led[row][i].port[PoC1]) &= ~(1 << led[row][i].pos[PoC1]);
			*(led[row][i].port[PoC1]) &= ~(1 << led[row][i].pos[PoC1]);
		}
}

//se aprind randurile in cascada
void efect1()
{
	int nr = 5;
	
	while (nr > 0){
	
		for( j=0; j< 3;j++){
		
			_delay_ms(3000);
			lit_row(j);
			_delay_ms(3000);
			clean_row(j);
			
			}
		nr--;
		}

}

void efect2(){

 int nr = 5;
 
 while(nr > 0){
 
	_delay_ms(3000);
	
	lit_row(0);
	lit_row(2);
	*(led[1][0].port[PoC1]) |= (1 << led[1][0].pos[PoC1]);
	*(led[1][2].port[PoC1]) |= (1 << led[1][2].pos[PoC1]);
	
	_delay_ms(3000);
	
	clean_row(0);
	clean_row(2);
	*(led[1][0].port[PoC1]) &= ~(1 << led[1][0].pos[PoC1]);
	*(led[1][2].port[PoC1]) &= ~(1 << led[1][2].pos[PoC1]);
	
	_delay_ms(3000);
	
	*(led[1][1].port[PoC1]) |= (1 << led[1][1].pos[PoC1]);
	
	_delay_ms(3000);
	
	*(led[1][1].port[PoC1]) &= ~(1 << led[1][1].pos[PoC1]);
	
	nr--;
	}
	
}

void efect3(){

	clean_led();
	int nr = 3;
	
	while( nr > 0){
	
			for( i = 0 ;i < 3; i++)
				for(  j = 0; j < 3; j++){
					if( i == 0 || i ==2){
					
						_delay_ms(2000);
						*(led[i][j].port[PoC1]) |= (1 << led[i][j].pos[PoC1]);
						_delay_ms(2000);
						*(led[i][j].port[PoC1]) &= ~(1 << led[i][j].pos[PoC1]);
					}
					else if (i == 1) {
					
						_delay_ms(2000);
						*(led[i][2-j].port[PoC1]) |= (1 << led[i][2-j].pos[PoC1]);
						_delay_ms(2000);
						*(led[i][2-j].port[PoC1]) &= ~(1 << led[i][2-j].pos[PoC1]);
					}
				}
		
			for( i = 2 ;i >= 0; i--)
				for( j = 2; j >= 0; j--){
					if( i == 0 || i ==2){
					
						_delay_ms(2000);
						*(led[i][j].port[PoC1]) |= (1 << led[i][j].pos[PoC1]);
						_delay_ms(2000);
						*(led[i][j].port[PoC1]) &= ~(1 << led[i][j].pos[PoC1]);
					}
					else if (i ==1) {
					
						_delay_ms(2000);
						*(led[i][2-j].port[PoC1]) |= (1 << led[i][2-j].pos[PoC1]);
						_delay_ms(2000);
						*(led[i][2-j].port[PoC1]) &= ~(1 << led[i][2-j].pos[PoC1]);
					}
				}
		nr --;
	}
					
}

void efect4(){

	int nr = 3;
	clean_led();
	
	while(nr > 0){ 
	
		_delay_ms(3000);
		clean_led();
		all_led();
		_delay_ms(3000);
		clean_led();
		nr--;
	}

}

int main()
{
	set_led();
	efect2();
	efect3();
	efect1();
	efect4();
		

}